#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <richedit.h>
#include "AkelDLL.h"
#include "StrFunc.h"


//Include string functions
#define xstrstrA
#define xstrstrW
#include "StrFunc.h"


//Identification
extern "C" void __declspec(dllexport) DllAkelPadID(PLUGINVERSION *pv)
{
  pv->dwAkelDllVersion=AKELDLL;
  pv->dwExeMinVersion3x=MAKE_IDENTIFIER(3, 7, 4, 0);
  pv->dwExeMinVersion4x=MAKE_IDENTIFIER(4, 4, 0, 0);
  pv->pPluginName="LinkExtract";
}

//Plugin extern function
extern "C" void __declspec(dllexport) Main(PLUGINDATA *pd)
{
  EDITINFO ei;
  GETTEXTRANGE gtr;
  CHARRANGE cr;
  char *pTextCount;
  wchar_t *wpTextCount;
  char *pStrEnd;
  wchar_t *wpStrEnd;
  char *pStrBegin;
  wchar_t *wpStrBegin;
  char chQuote;
  wchar_t wchQuote;
  BOOL bEgual=FALSE;

  if (pd->lpbAutoLoad)
  {
    *pd->lpbAutoLoad=FALSE;
    return;
  }

  //If plugin autoload on start, then exit
  if (pd->bOnStart) return;

  if (SendMessage(pd->hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
  {
    if (!ei.bReadOnly)
    {
      SendMessage(pd->hWndEdit, EM_EXGETSEL, 0, (LPARAM)&cr);
      if (cr.cpMin == cr.cpMax)
      {
        cr.cpMin=0;
        cr.cpMax=-1;
        SendMessage(pd->hWndEdit, EM_EXSETSEL, 0, (LPARAM)&cr);
        SendMessage(pd->hWndEdit, EM_EXGETSEL, 0, (LPARAM)&cr);
      }
      gtr.cpMin=cr.cpMin;
      gtr.cpMax=cr.cpMax;

      if (SendMessage(pd->hMainWnd, AKD_GETTEXTRANGE, (WPARAM)pd->hWndEdit, (LPARAM)&gtr))
      {
        if (pd->bOldWindows)
        {
          pTextCount=pStrEnd=(char *)gtr.pText;

          while (xstrstrA(pStrEnd, (DWORD)-1, " href", FALSE, &pStrBegin, &pStrEnd))
          {
            while (*pStrEnd == ' ' || *pStrEnd == '\t' || *pStrEnd == '=')
            {
              if (*pStrEnd == '=') bEgual=TRUE;
              ++pStrEnd;
            }
            if (!bEgual) continue;
            bEgual=FALSE;

            if (*pStrEnd == '\"' || *pStrEnd == '\'')
            {
              chQuote=*pStrEnd++;

              while (*pStrEnd != chQuote && *pStrEnd != '\0')
              {
                if (*pStrEnd == '\r')
                  ++pStrEnd;
                else
                  *pTextCount++=*pStrEnd++;
              }
            }
            else
            {
              while (*pStrEnd != ' ' && *pStrEnd != '\t' && *pStrEnd != '\r' && *pStrEnd != '>' && *pStrEnd != '\0')
                *pTextCount++=*pStrEnd++;
            }
            *pTextCount++='\r';
          }
          *pTextCount='\0';

          SendMessage(pd->hMainWnd, AKD_REPLACESELA, (WPARAM)pd->hWndEdit, (LPARAM)gtr.pText);
          gtr.cpMax=gtr.cpMin;
          cr.cpMax=cr.cpMin + (pTextCount - (char *)gtr.pText);
          SendMessage(pd->hWndEdit, EM_EXSETSEL, 0, (LPARAM)&gtr);
          SendMessage(pd->hWndEdit, EM_EXSETSEL, 0, (LPARAM)&cr);
        }
        else
        {
          wpTextCount=wpStrEnd=(wchar_t *)gtr.pText;

          while (xstrstrW(wpStrEnd, (DWORD)-1, L" href", FALSE, &wpStrBegin, &wpStrEnd))
          {
            while (*wpStrEnd == ' ' || *wpStrEnd == '\t' || *wpStrEnd == '=')
            {
              if (*wpStrEnd == '=') bEgual=TRUE;
              ++wpStrEnd;
            }
            if (!bEgual) continue;
            bEgual=FALSE;

            if (*wpStrEnd == '\"' || *wpStrEnd == '\'')
            {
              wchQuote=*wpStrEnd++;

              while (*wpStrEnd != wchQuote && *wpStrEnd != '\0')
              {
                if (*wpStrEnd == '\r')
                  ++wpStrEnd;
                else
                  *wpTextCount++=*wpStrEnd++;
              }
            }
            else
            {
              while (*wpStrEnd != ' ' && *wpStrEnd != '\t' && *wpStrEnd != '\r' && *wpStrEnd != '>' && *wpStrEnd != '\0')
                *wpTextCount++=*wpStrEnd++;
            }
            *wpTextCount++='\r';
          }
          *wpTextCount='\0';

          SendMessage(pd->hMainWnd, AKD_REPLACESELW, (WPARAM)pd->hWndEdit, (LPARAM)gtr.pText);
          gtr.cpMax=gtr.cpMin;
          cr.cpMax=cr.cpMin + (wpTextCount - (wchar_t *)gtr.pText);
          SendMessage(pd->hWndEdit, EM_EXSETSEL, 0, (LPARAM)&gtr);
          SendMessage(pd->hWndEdit, EM_EXSETSEL, 0, (LPARAM)&cr);
        }
        SendMessage(pd->hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
      }
    }
    else MessageBeep(MB_OK);
  }
}

//Entry point
extern "C" BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  if (fdwReason == DLL_PROCESS_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_DETACH)
  {
  }
  else if (fdwReason == DLL_PROCESS_DETACH)
  {
  }
  return TRUE;
}
